/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCorePerson.TCorePersonPath;
import de.ship.db.tables.TWebApplication.TWebApplicationPath;
import de.ship.db.tables.records.TWebSessionstateRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TWebSessionstate extends TableImpl<TWebSessionstateRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_web_sessionstate</code>
     */
    public static final TWebSessionstate T_WEB_SESSIONSTATE = new TWebSessionstate();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TWebSessionstateRecord> getRecordType() {
        return TWebSessionstateRecord.class;
    }

    /**
     * The column <code>common_dd.t_web_sessionstate.lastchange</code>.
     */
    public final TableField<TWebSessionstateRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_web_sessionstate.pk</code>. primary key
     */
    public final TableField<TWebSessionstateRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "primary key");

    /**
     * The column <code>common_dd.t_web_sessionstate.fk_application</code>.
     * foreign key to t_web_application entry
     */
    public final TableField<TWebSessionstateRecord, Integer> FK_APPLICATION = createField(DSL.name("fk_application"), SQLDataType.INTEGER.nullable(false), this, "foreign key to t_web_application entry");

    /**
     * The column <code>common_dd.t_web_sessionstate.fk_usnr</code>. foreign key
     * to user
     */
    public final TableField<TWebSessionstateRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER.nullable(false), this, "foreign key to user");

    /**
     * The column <code>common_dd.t_web_sessionstate.key</code>. key of this
     * parameter
     */
    public final TableField<TWebSessionstateRecord, String> KEY = createField(DSL.name("key"), SQLDataType.CLOB.nullable(false), this, "key of this parameter");

    /**
     * The column <code>common_dd.t_web_sessionstate.value</code>. value of this
     * parameter
     */
    public final TableField<TWebSessionstateRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB, this, "value of this parameter");

    private TWebSessionstate(Name alias, Table<TWebSessionstateRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TWebSessionstate(Name alias, Table<TWebSessionstateRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_web_sessionstate</code> table
     * reference
     */
    public TWebSessionstate(String alias) {
        this(DSL.name(alias), T_WEB_SESSIONSTATE);
    }

    /**
     * Create an aliased <code>common_dd.t_web_sessionstate</code> table
     * reference
     */
    public TWebSessionstate(Name alias) {
        this(alias, T_WEB_SESSIONSTATE);
    }

    /**
     * Create a <code>common_dd.t_web_sessionstate</code> table reference
     */
    public TWebSessionstate() {
        this(DSL.name("t_web_sessionstate"), null);
    }

    public <O extends Record> TWebSessionstate(Table<O> path, ForeignKey<O, TWebSessionstateRecord> childPath, InverseForeignKey<O, TWebSessionstateRecord> parentPath) {
        super(path, childPath, parentPath, T_WEB_SESSIONSTATE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TWebSessionstatePath extends TWebSessionstate implements Path<TWebSessionstateRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TWebSessionstatePath(Table<O> path, ForeignKey<O, TWebSessionstateRecord> childPath, InverseForeignKey<O, TWebSessionstateRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TWebSessionstatePath(Name alias, Table<TWebSessionstateRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TWebSessionstatePath as(String alias) {
            return new TWebSessionstatePath(DSL.name(alias), this);
        }

        @Override
        public TWebSessionstatePath as(Name alias) {
            return new TWebSessionstatePath(alias, this);
        }

        @Override
        public TWebSessionstatePath as(Table<?> alias) {
            return new TWebSessionstatePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TWebSessionstateRecord, Integer> getIdentity() {
        return (Identity<TWebSessionstateRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TWebSessionstateRecord> getPrimaryKey() {
        return Keys.PK_WEB_SESSIONSTATE;
    }

    @Override
    public List<UniqueKey<TWebSessionstateRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_WEB_SESSIONSTATE);
    }

    @Override
    public List<ForeignKey<TWebSessionstateRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_WEB_SESSIONSTATE__FK_WEB_SESSIONSTATE_APP, Keys.T_WEB_SESSIONSTATE__FK_WEB_SESSIONSTATE_USNR);
    }

    private transient TWebApplicationPath _tWebApplication;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_web_application</code> table.
     */
    public TWebApplicationPath tWebApplication() {
        if (_tWebApplication == null)
            _tWebApplication = new TWebApplicationPath(this, Keys.T_WEB_SESSIONSTATE__FK_WEB_SESSIONSTATE_APP, null);

        return _tWebApplication;
    }

    private transient TCorePersonPath _tCorePerson;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_person</code>
     * table.
     */
    public TCorePersonPath tCorePerson() {
        if (_tCorePerson == null)
            _tCorePerson = new TCorePersonPath(this, Keys.T_WEB_SESSIONSTATE__FK_WEB_SESSIONSTATE_USNR, null);

        return _tCorePerson;
    }

    @Override
    public TWebSessionstate as(String alias) {
        return new TWebSessionstate(DSL.name(alias), this);
    }

    @Override
    public TWebSessionstate as(Name alias) {
        return new TWebSessionstate(alias, this);
    }

    @Override
    public TWebSessionstate as(Table<?> alias) {
        return new TWebSessionstate(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TWebSessionstate rename(String name) {
        return new TWebSessionstate(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TWebSessionstate rename(Name name) {
        return new TWebSessionstate(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TWebSessionstate rename(Table<?> name) {
        return new TWebSessionstate(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebSessionstate where(Condition condition) {
        return new TWebSessionstate(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebSessionstate where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebSessionstate where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebSessionstate where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebSessionstate where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebSessionstate where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebSessionstate where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TWebSessionstate where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebSessionstate whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TWebSessionstate whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
